clc
Ifread=false;

if Ifread
    clear all
    FileName='HK data.xlsx'
    Data=xlsread(FileName,'To Matlab','A4:AN2516');
    disp 'Data read'
else
    load HKtab Data
end

% A tab is a cross-tab of a given set of variables. A group comprises all
% cross-tabs containing the same number of variables.

WeightVar=39;
LeftVars=[4,2,6,9];
nRows=[4,6,4,1];
Tabs=eye(4);  % one-way
Tabs=[Tabs;1,1,0,0;1,0,1,0;1,0,0,1;0,1,1,0;0,1,0,1;0,0,1,1];  % two-way
Tabs=[Tabs;1,1,1,0;1,1,0,1;1,0,1,1;0,1,1,1]; %  three-way
Tabs=[Tabs;1,1,1,1];  %  four-way
binaries=[0,0,0,0;0,0,0,1;0,0,1,0;0,0,1,1;0,1,0,0;0,1,0,1;0,1,1,0;0,1,1,1;1,0,0,0;1,0,0,1;1,0,1,0;1,0,1,1;1,1,0,0;1,1,0,1;1,1,1,0;1,1,1,1];
NTab=size(Tabs,1);

Nob=size(Data,1);
weights=Data(:,WeightVar);
NCrossRows=sum(2.^(1:4).*nRows);
CrossTabs=zeros(NCrossRows,9);  %  Columns of CrossTabs: 1-4: values of the
%  4 variables; 5 number in this cell; 6 sum of weights in this cell; 7
%  number fraction; 8 weight fraction; 9 total number

tabBase=1; %  row number of the top row of the current tab
for tab=1:NTab  %  Put the variable number appearances in CrossTabs
    nvar=sum(Tabs(tab,:));  %  number of variables in this tab
    nrow=2^nvar;  % number of rows in this tab 
    incvar=0; % variable counter in current tab
    for var=1:4
        if Tabs(tab,var)>0  %  this variable is included in the current tab
            incvar=incvar+1;
            for row=1:nrow
                CrossTabs(tabBase+row-1,var)=binaries(row,5-incvar);
            end
        end
    end
    tabBase=tabBase+nrow;
end

for obs=1:Nob
    y=Data(obs,LeftVars); % row vector of the four variables, properly ordered
    tabBase=1; %  row number of the top row of the current tab
    for tab=1:NTab  %  updating of all tabs for this obs, if all vars are not NA
        bad=false;
        for var=1:4  %  Check at the tab level for included observations
            if Tabs(tab,var)==1 && isnan(y(var))  %  relevant variable for this tab and a NAN
                bad=true;  %  skip this tab for this obs
                break
            end
        end
        % bad=bad && (isnan(weight(obs))||weight(obs)<0);
        if ~bad;
             
            %  Add to the rows to the crosstab array for this set of variables

            nvar=sum(Tabs(tab,:));  %  number of variables in this block
            nrow=2^nvar; %  number of rows
            row=1;  %  row within the current tab
            incvar=0; % variable counter in current tab
            for var=1:4
                if Tabs(tab,var)>0  % If this variable is included in the current tab
                    if y(var)>0  %  and this variable is true, then
                        row=row+2^incvar;  %  row  is the row within this tab affected by this true value
                    end
                    incvar=incvar+1;
                end
            end
            row=row+tabBase-1;
            CrossTabs(row,5)=CrossTabs(row,5)+1;  %  count
            CrossTabs(row,6)=CrossTabs(row,6)+weights(obs);  %  sum of weights
            tabBase=tabBase+nrow;
        end 
    end
end

%  Add sums and distributions--row 7 is number fraction; row 8 is weight
%  fraction, and row 9 is total number

tabBase=1; %  row number of the top row of the current tab
for tab=1:NTab  %  Put the variable number appearances in CrossTabs
    nvar=sum(Tabs(tab,:));  %  number of variables in this tab
    nrow=2^nvar;  % number of rows in this tab 
    sumCount=sum(CrossTabs(tabBase:tabBase+nrow-1,5));
    CrossTabs(tabBase:tabBase+nrow-1,7)=CrossTabs(tabBase:tabBase+nrow-1,5)/sumCount;
    sumWeight=sum(CrossTabs(tabBase:tabBase+nrow-1,6));
    CrossTabs(tabBase:tabBase+nrow-1,8)=CrossTabs(tabBase:tabBase+nrow-1,6)/sumWeight;
    CrossTabs(tabBase:tabBase,9)=sumCount;
    tabBase=tabBase+nrow;
end









